import { GatsbyCache } from 'gatsby';
export declare const buildBase64URL: (contentType: string, base64: string) => string;
/**
 * Fetch the base64 image for an imgix url, and cache the request in the Gatsby
 * cache
 */
export declare const fetchImgixBase64Image: (cache: GatsbyCache) => (url: string) => Promise<string>;
export declare type HexString = string;
/**
 * Fetch the dominant color for a given imgix url, and cache the request in the
 * Gatsby cache
 */
export declare const fetchImgixDominantColor: (cache: GatsbyCache) => (buildURL: (params: Record<string, unknown>) => string) => Promise<HexString>;
//# sourceMappingURL=fetchBase64Image.d.ts.map