import { GatsbyCache } from 'gatsby';
import { IImgixURLBuilder } from '../common/imgix-js-core-wrapper';
export declare type IImgixMetadata = {
    'Content-Type': string;
    PixelWidth: number;
    PixelHeight: number;
};
/**
 * Fetch the metadata for a given image from the imgix API, and cache the result
 * @param cache Gatsby cache
 * @param client Instance of the imgix client
 * @returns The metadata, or an error
 */
export declare const fetchImgixMetadata: (cache: GatsbyCache, client: IImgixURLBuilder) => (url: string) => Promise<IImgixMetadata>;
//# sourceMappingURL=fetchImgixMetadata.d.ts.map