"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.findPossibleURLsInNode = exports.invariant = exports.noop = void 0;
var noop = function () {
    // noop
};
exports.noop = noop;
function invariant(condition, msg, reporter) {
    if (!condition)
        reporter.panic("Invariant failed: ".concat(msg));
}
exports.invariant = invariant;
function isURL(str) {
    var pattern = new RegExp('\\/\\/' + // the first two slashes after the protocol
        '((([a-z\\d]([a-z\\d-]*[a-z\\d])*)\\.?)+[a-z]{2,}|' + // domain name
        '((\\d{1,3}\\.){3}\\d{1,3}))' + // OR ip (v4) address
        '(\\:\\d+)?(\\/[-a-z\\d%_.~+]*)*' + // port and path
        '(\\?[;&a-z\\d%_.~+=-]*)?' + // query string
        '(\\#[-a-z\\d_]*)?$', 'i');
    return pattern.test(str);
}
var findPossibleURLsInNode = function (node, depth) {
    if (depth === void 0) { depth = 0; }
    if (depth > 5) {
        return [];
    }
    return Object.entries(node).reduce(function (p, _a) {
        var key = _a[0], value = _a[1];
        if (typeof value === 'string' && isURL(value)) {
            return __spreadArray(__spreadArray([], p, true), [{ path: key, value: value }], false);
        }
        if (typeof value === 'object' && value != null) {
            return __spreadArray(__spreadArray([], p, true), (0, exports.findPossibleURLsInNode)(value, depth + 1).map(function (_a) {
                var path = _a.path, value = _a.value;
                return ({
                    path: "".concat(key, ".").concat(path),
                    value: value,
                });
            }), true);
        }
        return p;
    }, []);
};
exports.findPossibleURLsInNode = findPossibleURLsInNode;
//# sourceMappingURL=utils.js.map