"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createImgixUrlSchemaFieldConfig = exports.createImgixUrlFieldConfig = void 0;
var ramda_1 = require("ramda");
var createExternalHelper_1 = require("../../common/createExternalHelper");
var graphqlTypes_1 = require("./graphqlTypes");
/**
 * Create the GraphQL field config for the "url" field that will exist on the
 * imgixImage type
 * @param param0
 * @param param0.imgixClient The imgix client to use to build the URL
 * @param param0.resolveUrl The function to resolve the URL from the source data
 * @param param0.defaultParams The default params to use when building the fixed image URL
 * @param param0.paramsInputType The GraphQL type to use for the params input
 * @returns A GraphQL field config for a "url" size image
 */
var createImgixUrlFieldConfig = function (_a) {
    var imgixClient = _a.imgixClient, resolveUrl = _a.resolveUrl, defaultParams = _a.defaultParams, paramsInputType = _a.paramsInputType;
    return ({
        type: graphqlTypes_1.gatsbySourceImgixUrlFieldType,
        description: 'A plain imgix URL with the URL and params applied.',
        args: {
            imgixParams: {
                type: paramsInputType,
                defaultValue: {},
            },
        },
        resolve: function (rootValue, args) { return __awaiter(void 0, void 0, void 0, function () {
            var url;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, resolveUrl(rootValue)];
                    case 1:
                        url = _b.sent();
                        if (!url) {
                            return [2 /*return*/, undefined];
                        }
                        return [2 /*return*/, imgixClient.buildURL(url, (0, ramda_1.mergeRight)(defaultParams !== null && defaultParams !== void 0 ? defaultParams : {}, (0, graphqlTypes_1.unTransformParams)((_a = args.imgixParams) !== null && _a !== void 0 ? _a : {})))];
                }
            });
        }); },
    });
};
exports.createImgixUrlFieldConfig = createImgixUrlFieldConfig;
exports.createImgixUrlSchemaFieldConfig = (0, createExternalHelper_1.createExternalHelper)(exports.createImgixUrlFieldConfig);
//# sourceMappingURL=createImgixUrlFieldConfig.js.map