import { GatsbyCache } from 'gatsby';
import { IImgixURLBuilder } from '../../common/imgix-js-core-wrapper';
export declare type IResolvedDimensions = {
    width: number;
    height: number;
};
/**
 * Calculate the dimensions of an image, using manual dimensions, if provided,
 * or otherwise by using the imgix API
 * @param param0
 * @param param0.url The URL of the image
 * @param param0.manualWidth The width of the image, if known
 * @param param0.manualHeight The height of the image, if known
 * @param param0.cache Gatsby cache
 * @param param0.client Instance of the imgix client
 * @returns The width and height of the image, or an error
 */
export declare const resolveDimensions: ({ url, manualHeight, manualWidth, cache, client, }: {
    manualHeight?: number | null | undefined;
    manualWidth?: number | null | undefined;
    cache: GatsbyCache;
    url: string;
    client: IImgixURLBuilder;
}) => Promise<IResolvedDimensions>;
//# sourceMappingURL=resolveDimensions.d.ts.map