import { createImgixURLBuilder } from './common/imgix-js-core-wrapper';
import { buildImgixGatsbyTypes } from './modules/gatsby-plugin/typeBuilder';
export declare const createImgixGatsbyTypes: ({ imgixClientOptions, ...params }: Omit<{
    allowlistFields?: ("url" | "fixed" | "fluid" | "gatsbyImageData")[] | undefined;
    namespace?: string | undefined;
    imgixClient: import("./common/imgix-js-core-wrapper").IImgixURLBuilder;
    resolveUrl: import("./common/utils").ImgixSourceDataResolver<unknown, string>;
    resolveHeight?: import("./common/utils").ImgixSourceDataResolver<unknown, number | undefined> | undefined;
    resolveWidth?: import("./common/utils").ImgixSourceDataResolver<unknown, number | undefined> | undefined;
    defaultParams?: Partial<Record<"auto" | "fill" | "blendalign" | "ba" | "blend" | "blendalpha" | "balph" | "blendcolor" | "blend-clr" | "blendclr" | "faces" | "blendcrop" | "bc" | "crop" | "blendfit" | "bf" | "blendh" | "bh" | "hue" | "blendmode" | "bm" | "blendpad" | "bp" | "blendsize" | "bs" | "blendw" | "bw" | "blendx" | "bx" | "blendy" | "by" | "b" | "border" | "width" | "dpr" | "palette" | "mask" | "duotone" | "fillcolor" | "blur" | "fit" | "f" | "h" | "interval" | "gifq" | "transparency" | "height" | "invert" | "inv" | "ma" | "markalign" | "mark" | "markalpha" | "malph" | "mb" | "markbase" | "mf" | "markfit" | "markw" | "markh" | "mh" | "mp" | "markpad" | "ms" | "markscale" | "mtile" | "marktile" | "mw" | "mx" | "markx" | "my" | "marky" | "m" | "maskbg" | "max-height" | "max-width" | "min-height" | "min-width" | "monochrome" | "mono" | "or" | "annotation" | "reverse" | "trim" | "trimcolor" | "trimmd" | "trimpad" | "trimsd" | "trimtol" | "txtalign" | "ta" | "txt" | "txtclip" | "tcl" | "txtcolor" | "txt-clr" | "txtclr" | "tc" | "txtfit" | "tf" | "txtfont" | "txtlead" | "txtlig" | "txtlinecolor" | "txt-line-clr" | "txtlineclr" | "txtline" | "tl" | "txtpad" | "tp" | "txtshad" | "tsh" | "tsz" | "txtsize" | "txttrack" | "tt" | "txtwidth" | "txtx" | "txty" | "t" | "usm" | "rottype" | "rott" | "txtbox" | "tba" | "tbcl" | "txtbox-clr" | "tbc" | "tbf" | "tbhang" | "tbh" | "tblead" | "txtbox-line-clr" | "txtbox-lineclr" | "tbl" | "tbp" | "tbsh" | "tbsz" | "tbt" | "tbw" | "tbx" | "tby" | "blend-align" | "blend-alpha" | "blend-color" | "blend-crop" | "blend-fit" | "blend-h" | "blend-mode" | "blend-pad" | "blend-size" | "blend-w" | "blend-x" | "blend-y" | "fill-color" | "gif-q" | "mark-align" | "mark-alpha" | "mark-base" | "mark-fit" | "mark-h" | "mark-pad" | "mark-scale" | "mark-tile" | "mark-w" | "mark-x" | "mark-y" | "mask-bg" | "max-h" | "max-w" | "min-h" | "min-w" | "orient" | "pdf-annotation" | "trim-color" | "trim-md" | "trim-pad" | "trim-sd" | "trim-tol" | "txt-align" | "txt-clip" | "txt-color" | "txt-fit" | "txt-font" | "txt-lead" | "txt-lig" | "txt-line-color" | "txt-line" | "txt-pad" | "txt-shad" | "txt-size" | "txt-track" | "txt-width" | "txt-x" | "txt-y" | "w" | "ar" | "bg-remove" | "bg-remove-fallback" | "bg" | "border-bottom" | "border-left" | "border-radius-inner" | "border-radius" | "border-right" | "border-top" | "bri" | "ch" | "chromasub" | "colorquant" | "colors" | "con" | "corner-radius" | "cs" | "dl" | "dpi" | "duotone-alpha" | "exp" | "expires" | "faceindex" | "facepad" | "flip" | "fm" | "fp-debug" | "fp-x" | "fp-y" | "fp-z" | "fps" | "frame" | "gam" | "grid-colors" | "grid-size" | "high" | "htn" | "iptc" | "loop" | "lossless" | "mark-rot" | "nr" | "nrs" | "pad-bottom" | "pad-left" | "pad-right" | "pad-top" | "pad" | "page" | "prefix" | "px" | "q" | "rect" | "rot" | "sat" | "sepia" | "shad" | "sharp" | "skip" | "usmrad" | "vib", string | number | boolean | string[] | number[] | boolean[] | null | undefined>> | undefined;
    cache: import("gatsby").GatsbyCache;
}, "imgixClient" | "resolveUrl" | "resolveWidth" | "resolveHeight"> & {
    imgixClientOptions?: Parameters<typeof createImgixURLBuilder>[0];
    resolveUrl: (source: any) => string | null;
    resolveWidth?: ((source: any) => number | undefined) | undefined;
    resolveHeight?: ((source: any) => number | undefined) | undefined;
}) => {
    types: import("graphql-compose").ObjectTypeComposerAsObjectDefinition<any, unknown>[];
    fields: Record<"url" | "fixed" | "fluid" | "gatsbyImageData", import("graphql-compose").ObjectTypeComposerFieldConfigAsObjectDefinition<any, any, any>>;
    inputTypes: import("graphql-compose").InputTypeComposerAsObjectDefinition[];
    enumTypes: import("graphql-compose").EnumTypeComposerAsObjectDefinition[];
};
export * from './pluginHelpers.browser';
//# sourceMappingURL=pluginHelpers.d.ts.map